== Changelog ==

= 6.5.4 (2026-02-26) =
* `[Fixed]` Displaying notification about Cloudflare cache

= 6.5.3 (2026-01-24) =
* `[Changed]` The Pass Thru loading mode is now restricted to standard WordPress directory structures only

= 6.5.2 (2026-01-24) =
* `[Security]` Replaced cURL-based fetching with native readfile(), implemented a whitelist of trusted website URLs and stricter extension validation in the Pass Thru loading mode to prevent unauthorized server-side requests (CVE-2026-1356)
* `[Security]` Implemented physical path identity verification for the Pass Thru loading mode using realpath() to provide extra protection against Directory Traversal
* `[Security]` Added X-Content-Type-Options: nosniff header for browser-side protection in the Pass Thru loading mode
* `[Fixed]` Priority logic for loading next-generation image formats (AVIF/WebP)
* `[Added]` Automatic refresh of an image loading mode after a plugin update
* `[Added]` Significant performance boost for the Pass Thru loading mode by direct filesystem access instead of cURL requests
* `[Added]` Support for Content-Length headers to optimize image delivery in the Pass Thru loading mode

= 6.5.1 (2026-01-23) =
* Version superseded by 6.5.2

= 6.5.0 (2026-01-11) =
* `[Fixed]` Rewrite rules to handle environments where RewriteRule may receive an absolute filesystem path
* `[Changed]` Field to select the format to which the images should be converted
* `[Added]` Settings field to modify the prefix used in RewriteRule to fix the absolute filesystem path issue

= 6.4.0 (2025-12-08) =
* `[Security]` Added permission check to ensure the user can edit the post before manually converting an image in the Media Library (CVE-2025-13750)
* `[Security]` Added stricter permission checks to REST API endpoints for authenticated users

= 6.3.2 (2025-11-24) =
* `[Added]` Support for WordPress 6.9

= 6.3.1 (2025-11-09) =
* `[Fixed]` Support for Bunny CDN and BunnyCDN plugin
* `[Fixed]` Support for QUIC.cloud CDN

= 6.3.0 (2025-10-28) =
* `[Changed]` Message about rewrites_uploads_blocked server configuration error

= 6.2.4 (2025-09-09) =
* `[Fixed]` Deprecated notice for implicitly nullable parameter when converting images

= 6.2.3 (2025-09-02) =
* `[Fixed]` Unknown error when converting images when file is unavailable or file size verification failed

= 6.2.2 (2025-04-29) =
* `[Security]` Update of Axios HTTP client

= 6.2.1 (2025-04-01) =
* `[Fixed]` Handling of excluded directories when uploading new images
* `[Added]` Error detection of required functions in disable_functions list in PHP configuration
* `[Added]` Support for WordPress 6.8

= 6.2.0 (2024-12-18) =
* `[Changed]` Minimum required PHP version from 7.0 to 7.1
* `[Added]` Compatibility with PHP 8.4

= 6.1.3 (2024-11-19) =
* `[Fixed]` Translations in command registration for WP-CLI
* `[Added]` Support for WordPress 6.7

= 6.1.2 (2024-10-26) =
* `[Fixed]` Removing converted files after uninstalling plugin

= 6.1.1 (2024-10-02) =
* `[Changed]` Bulk Optimization of Images section

= 6.1.0 (2024-09-13) =
* `[Removed]` Filter `webpc_supported_source_directory`
* `[Fixed]` Handling of excluded directories when uploading new images
* `[Fixed]` Handling of excluded filenames when uploading new images
* `[Fixed]` Adding support for custom directories using webpc_source_directories filter
* `[Fixed]` Verification of rewrites_not_working server configuration error when HTTP referer is required

= 6.0.0 (2024-08-28) =
* `[Fixed]` Generating statistics on plugin settings page when WebP format is unchecked
* `[Fixed]` Restoring original images in Media Library
* `[Changed]` Optimization statistics in Media Library
* `[Added]` Warnings with explanations in plugin settings field: Image loading mode

= 5.13.1 (2024-08-04) =
* `[Changed]` Optimization statistics in Media Library

= 5.13.0 (2024-06-27) =
* `[Fixed]` Filter `webpc_option_quality_levels` to change conversion quality levels
* `[Added]` Support for WordPress 6.6

= 5.12.5 (2024-04-15) =
* `[Fixed]` Modification of plugin settings via filters

= 5.12.4 (2024-04-12) =
* `[Fixed]` Support for changed upload directory path based on absolute path from upload_path option
* `[Fixed]` UX of plugin settings page
* `[Changed]` Error message for rewrites_not_executed error in server configuration

= 5.12.3 (2024-03-19) =
* `[Fixed]` Support for changed upload directory path based on upload_path option

= 5.12.2 (2024-03-14) =
* `[Changed]` Verification of rewrites_not_executed server configuration error
* `[Added]` Support for changed upload directory path based on upload_path option
* `[Added]` Support for WordPress 6.5

= 5.12.1 (2024-02-15) =
* `[Fixed]` Verification of rewrites_not_executed server configuration error when there is also a problem with the Gd or Imagick libraries
* `[Changed]` Error message for bypassing_apache error in server configuration
* `[Added]` Possibility to add directory paths in the Excluded directories field in Advanced Settings

= 5.12.0 (2024-01-18) =
* `[Changed]` Statistics about bulk optimization process
* `[Added]` Expert settings to overwrite paths for rewrite rules
* `[Added]` Improvement in verifying operation of redirections

= 5.11.5 (2023-12-07) =
* `[Added]` Compatibility with PHP 8.3
* `[Changed]` Error message for rewrites_not_executed error in server configuration
* `[Changed]` Error message for bypassing_apache error in server configuration

= 5.11.4 (2023-11-13) =
* `[Fixed]` Removing WebP files converted for AVIF format from /uploads-webpc directory after uninstalling plugin
* `[Fixed]` Statistics of conversion progress in WP-CLI
* `[Changed]` Error message for rewrites_not_executed error in server configuration
* `[Changed]` Error message for bypassing_apache error in server configuration
* `[Changed]` Error message for rewrites_cached error in server configuration

= 5.11.3 (2023-11-09) =
* `[Fixed]` Automatically conversion of images from /uploads directory, but not from Media Library
* `[Added]` Support for WordPress 6.4

= 5.11.2 (2023-10-16) =
* `[Added]` Button to expand/collapse list of directories to optimize in Bulk Optimization of Images section
* `[Added]` Notification about plugin requirements in WordPress Playground environment

= 5.11.1 (2023-10-02) =
* `[Fixed]` Duplicated rewrite rules for .jpeg files
* `[Changed]` Error message for rewrites_not_executed error in server configuration

= 5.11.0 (2023-09-27) =
* `[Added]` Ability to manually optimize selected images in Media Library
* `[Added]` Ability to manually undo optimization of selected images in Media Library

= 5.10.1 (2023-09-10) =
* `[Fixed]` Detection of bypassing_apache error in server configuration

= 5.10.0 (2023-09-09) =
* `[Fixed]` Removing files from /uploads-webpc directory after uninstalling plugin
* `[Changed]` Error message for rewrites_not_working error in server configuration
* `[Changed]` Verification of correct operation of rewrites from .htaccess file
* `[Added]` Changes to improve performance of plugin
* `[Added]` Changes to improve loading time of plugin settings

= 5.9.6 (2023-08-25) =
* `[Changed]` Maximum weight of supported files from 25 MB to 32 MB
* `[Added]` Displaying image in its original format by adding "?original" suffix to image URL
* `[Added]` Removing converted WebP files after deleting WebP format from "Supported output formats" list

= 5.9.5 (2023-07-31) =
* `[Changed]` Error message for bypassing_apache error in server configuration
* `[Added]` Clearing Cloudflare cache when activating and deactivating plugin

= 5.9.4 (2023-07-12) =
* `[Added]` Support for Bunny CDN and BunnyCDN plugin
* `[Added]` Support for WordPress 6.3

= 5.9.3 (2023-07-04) =
* `[Fixed]` Corrupted filenames in image URLs using Bypassing Nginx loading mode

= 5.9.2 (2023-07-03) =
* `[Fixed]` Suffix "-optimized" in image URLs using Bypassing Nginx loading mode
* `[Fixed]` Right-to-left styling of plugin settings page
* `[Added]` Error message when using WP-CLI when Conversion method is not available

= 5.9.1 (2023-05-24) =
* `[Changed]` Error message for rewrites_not_executed error in server configuration

= 5.9.0 (2023-05-20) =
* `[Fixed]` Conversion of images in WP-CLI using force flag
* `[Changed]` Error messages on plugin settings page
* `[Added]` Skipping backup files generated by other image optimization plugins

= 5.8.6 (2023-04-29) =
* `[Fixed]` Generating XML files using Pass Thru loading mode

= 5.8.5 (2023-04-07) =
* `[Added]` Skipping .jpg.webp, .jpeg.webp, .png.webp, and .gif.webp files generated by other image optimization plugins
* `[Added]` New parameter (to force reconversion) for webpc_convert_paths hook
* `[Added]` New parameter (to force reconversion) for webpc_convert_attachment hook

= 5.8.4 (2023-03-20) =
* `[Fixed]` Generating rules in .htaccess file when real DOCUMENT_ROOT path is different from WordPress root directory

= 5.8.3 (2023-03-09) =
* `[Fixed]` Converting images without EXIF data support using GD method
* `[Added]` Exception for blocked REST API endpoints by JWT Auth plugin

= 5.8.2 (2023-03-02) =
* `[Changed]` Written content in plugin settings
* `[Added]` Support for WordPress 6.2

= 5.8.1 (2023-02-27) =
* `[Fixed]` Converting using GD method without `exif_read_data` function available
* `[Fixed]` Redirects of images using Bypassing Nginx loading mode

= 5.8.0 (2023-02-20) =
* `[Fixed]` Generating output paths in WordPress Multisite Network
* `[Fixed]` Replacing URLs in Pass Thru loading mode for themes without get_header hook
* `[Changed]` Automatic clearing of cache generated by LiteSpeed Cache plugin
* `[Changed]` Error message for bypassing_apache error in server configuration
* `[Added]` Image loading mode: `Bypassing Nginx` (use when you have a problem with the bypassing_apache error)
* `[Added]` Support for defined /uploads directory using UPLOADS constant
* `[Added]` Support for Orientation parameter in EXIF data
* `[Added]` Automatic clearing of cache generated by Breeze plugin
* `[Added]` Automatic clearing of cache generated by Cache Enabler plugin
* `[Added]` Automatic clearing of cache generated by Hummingbird plugin
* `[Added]` Automatic clearing of cache generated by SiteGround Optimizer plugin
* `[Added]` Automatic clearing of cache generated by W3 Total Cache plugin
* `[Added]` Automatic clearing of cache generated by WP Fastest Cache plugin
* `[Added]` Automatic clearing of cache generated by WP-Optimize plugin
* `[Added]` Automatic clearing of cache generated by WP Super Cache plugin
* `[Added]` Support for defined value of WP_HOME for testing rewrites

= 5.7.1 (2023-02-04) =
* `[Changed]` Verification of rewrites_not_executed server configuration error

= 5.7.0 (2023-02-01) =
* `[Fixed]` Compatibility with PHP 8.2
* `[Changed]` Layout of settings in Advanced Settings tab
* `[Added]` Error detection of blocked rewrites for images from /uploads directory
* `[Added]` Exception for blocked REST API endpoints by external plugins

= 5.6.4 (2023-01-21) =
* `[Fixed]` Error detection of cached redirects of images to WebP files

= 5.6.3 (2023-01-10) =
* `[Changed]` Error message for bypassing_apache error in server configuration
* `[Changed]` Error message for rewrites_not_executed error in server configuration
* `[Changed]` Error message for rewrites_cached error in server configuration
* `[Changed]` Error message for rewrites_not_working error in server configuration
* `[Changed]` Error message for token_invalid error in server configuration
* `[Changed]` Error message for token_limit error in server configuration

= 5.6.2 (2023-01-05) =
* `[Changed]` List of extra features in Advanced settings
* `[Changed]` Notification about Cloudflare cache
* `[Added]` Ability to disable exclusion of converted images in backups generated by other plugins
* `[Added]` Error message for incorrect configuration of Cloudflare CDN cache
* `[Added]` Warning about unconverted images when deactivating plugin
* `[Added]` Warning when forcing all images to be reconverted

= 5.6.1 (2022-12-28) =
* `[Fixed]` No support for .jpeg files in default plugin settings
* `[Added]` Ability to auto clear Cloudflare CDN cache (beta version)

= 5.6.0 (2022-12-21) =
* `[Added]` Ability to convert images from /cache directory
* `[Added]` Automatic cleaning of LiteSpeed Cache
* `[Added]` Exception for blocked REST API endpoints by Disable REST API plugin
* `[Added]` Exception for blocked REST API endpoints by Disable WP REST API plugin
* `[Added]` Exception for blocked REST API endpoints by WordPress REST API Authentication plugin

= 5.5.1 (2022-11-29) =
* `[Fixed]` Cache for REST API responses using LiteSpeed Cache plugin
* `[Changed]` Authorization method for REST API endpoints

= 5.5.0 (2022-11-22) =
* `[Removed]` Error logging to debug.log file
* `[Changed]` Content of welcome notice after plugin installation
* `[Added]` Exclusion of directories from converting images in plugin settings
* `[Added]` Instruction in "Conversion strategy" field in plugin settings
* `[Added]` Possibility to disable rewrite inheritance in .htaccess files in plugin settings

= 5.4.2 (2022-11-14) =
* `[Added]` Possibility to re-convert files that have not been successfully converted (service mode must be active)

= 5.4.1 (2022-11-13) =
* `[Fixed]` Forcing images larger than original to be re-converted

= 5.4.0 (2022-11-12) =
* `[Fixed]` Converting using a Remote server when response is empty
* `[Changed]` URLs for REST API endpoints
* `[Added]` Conversion of missing images after selecting "Automatic removal of files in output formats larger than original" option
* `[Added]` Exclusion of files conversion from /wpmc-trash directory generated by Media Cleaner plugin
* `[Added]` Exclusion of files conversion from /__MACOSX directory

= 5.3.1 (2022-10-12) =
* `[Added]` Error handling while connecting to REST API

= 5.3.0 (2022-10-11) =
* `[Removed]` Action `webpc_convert_dir`
* `[Removed]` Filter `webpc_dir_files`
* `[Fixed]` Support for WordPress older than version 5.3
* `[Added]` List of files for optimization in tree form
* `[Added]` Handling unknown errors while converting with Imagick method

= 5.2.4 (2022-09-27) =
* `[Changed]` Messages displayed during bulk optimization of images
* `[Added]` Debug information about registered image sub-sizes

= 5.2.3 (2022-09-23) =
* `[Added]` Debug information about disabled functions

= 5.2.2 (2022-09-15) =
* `[Fixed]` Closing of admin notice

= 5.2.1 (2022-09-14) =
* `[Fixed]` Deleting converted files during plugin uninstallation

= 5.2.0 (2022-09-10) =
* `[Fixed]` Re-conversion of images modified after previous conversion
* `[Added]` Optimization statistics in Media Upload Popup
* `[Added]` Filter `webpc_source_directories` to add support for custom directories

= 5.1.0 (2022-08-28) =
* `[Fixed]` Exclusion of converted files from backup generated by UpdraftPlus plugin
* `[Added]` Optimization statistics in Media Library

= 5.0.1 (2022-08-26) =
* `[Removed]` Filter `webpc_uploads_prefix`
* `[Fixed]` Calculating number of images to convert in WP-CLI
* `[Fixed]` Converting files that contain plus sign in filename
* `[Changed]` Notification asking to clear cache for LiteSpeed
* `[Added]` Exclusion of converted files from backup generated by All-in-One WP Migration plugin
* `[Added]` Exclusion of converted files from backup generated by UpdraftPlus plugin
* `[Added]` Exclusion of converted files from backup generated by BackWPup plugin

= 5.0.0 (2022-08-20) =
* `[Changed]` Information about plugin operation and technical support on plugin settings page
* `[Changed]` Labels of options in plugin settings
* `[Changed]` Option field for configuration of quality level
* `[Changed]` Widget for conversion process
* `[Added]` Filter `webpc_htaccess_cache_control_private` to disable Cache-Control as private
* `[Added]` Statistics on number of converted images
* `[Added]` Tabs for plugin settings

= 4.5.1 (2022-07-22) =
* `[Removed]` Notification asking to clear cache for Cloudways
* `[Changed]` Error message for bypassing_apache error in server configuration

= 4.5.0 (2022-07-15) =
* `[Changed]` Plugin name from "WebP Converter to Media" to "Converter for Media"
* `[Removed]` "Browser Caching for files in output formats" option in plugin settings (will be active always)
* `[Removed]` "Force redirections to output formats for all domains" option in plugin settings (will be active always)
* `[Fixed]` Error handling about unreadable source or output path
* `[Changed]` Error message for bypassing_apache error in server configuration
* `[Changed]` Error message for rewrites_not_executed error in server configuration
* `[Added]` Limit of 3 attempts to image regeneration to avoid infinity loops
* `[Added]` Debug information about saved plugin data
* `[Added]` Notification asking to clear cache for Cloudways
* `[Added]` Action `webpc_after_conversion` to operation on output path after image conversion
* `[Added]` Filter `webpc_htaccess_mod_rewrite_inherit` to disable mod_rewrite inheritance
* `[Added]` Filter `webpc_htaccess_mod_rewrite_referer` to disable redirections to output formats for other domains

= 4.4.1 (2022-06-30) =
* `[Added]` Inheritance of mod_rewrite rules from parent directories
* `[Added]` Support for custom /wp-content directory name

= 4.4.0 (2022-06-19) =
* `[Changed]` Calculation of number of images to be converted
* `[Added]` Resizing of images before conversion
* `[Added]` Notification asking to clear cache for LiteSpeed

= 4.3.6 (2022-06-03) =
* `[Fixed]` Notification about Cloudflare cache

= 4.3.5 (2022-06-02) =
* `[Changed]` Generating rewrite rules for via .htaccess loading mode (applies to rewrites_not_working server configuration error)

= 4.3.4 (2022-05-10) =
* `[Changed]` Generating rewrite rules for via .htaccess loading mode (applies to rewrites_not_working server configuration error)
* `[Changed]` Message about rewrites_not_executed server configuration error

= 4.3.3 (2022-05-08) =
* `[Fixed]` Calculation of number of images to be converted
* `[Added]` Filter `webpc_option_quality_levels` to change conversion quality levels

= 4.3.2 (2022-04-20) =
* `[Added]` Conversion skip for animated GIF images
* `[Added]` New information about status of image conversion
* `[Added]` Ability to convert only to AVIF format

= 4.3.1 (2022-04-05) =
* `[Fixed]` Generating rewrite rules for via .htaccess loading mode

= 4.3.0 (2022-04-01) =
* `[Fixed]` Authorization of access to REST API
* `[Changed]` Description of plugin operation in plugin settings
* `[Added]` Command "wp webp-converter calculate" for WP-CLI
* `[Added]` Command "wp webp-converter regenerate" for WP-CLI
* `[Added]` Converting .webp files to AVIF format
* `[Added]` Support for environments where DOCUMENT_ROOT is different from WordPress installation directory

= 4.2.4 (2022-03-01) =
* `[Fixed]` Generating paths for via .htaccess loading mode

= 4.2.3 (2022-02-27) =
* `[Fixed]` Closing of admin notice

= 4.2.2 (2022-02-21) =
* `[Changed]` Error message for bypassing_apache error in server configuration
* `[Added]` Automatic continuation of conversion process after connection lost
* `[Added]` ICC/ICM profile support for conversion using Imagick
* `[Added]` Notification asking to clear cache for Cloudflare

= 4.2.1 (2022-02-17) =
* `[Fixed]` Cache settings for .htaccess rewrites
* `[Added]` Limit for error messages displayed while converting
* `[Added]` Support for plain permalink structure

= 4.2.0 (2022-02-13) =
* `[Removed]` Action `webpc_regenerate_all`
* `[Fixed]` Issue with plugin settings after changing Gd or Imagick library configuration
* `[Fixed]` Server configuration error detection when cURL is disabled
* `[Fixed]` URL for the server configuration tab
* `[Changed]` Automatically conversion of images after upload
* `[Changed]` Automatically conversion of images from outside the Media Library
* `[Changed]` Message for conversion error when converted file is larger than original
* `[Added]` List of allowed file extensions for cache rules in .htaccess file
* `[Added]` Status of automatic image conversion on the top bar in the WordPress Dashboard
* `[Added]` Debug information about plugin settings

= 4.1.2 (2022-01-29) =
* `[Fixed]` Validation of authorization token when images regeneration
* `[Fixed]` Validation of loaded images using Pass Thru method

= 4.1.1 (2022-01-19) =
* `[Fixed]` Loading images with special character in filename using Pass Thru method
* `[Changed]` Error messages on plugin settings page
* `[Added]` Value hiding for access token in plugin settings

= 4.1.0 (2022-01-12) =
* `[Fixed]` Auto-generation of rewrite rules for Multisite Network
* `[Fixed]` Detection of server configuration error related to non-working rewrites
* `[Fixed]` URL validation for Pass Thru loading mode
* `[Fixed]` Verification of supported formats by Imagick
* `[Changed]` Error messages on plugin settings page
* `[Changed]` Styles for plugin settings page
* `[Added]` Debug information about PHP configuration

= 4.0.5 (2022-01-04) =
* `[Changed]` Modal when deactivating plugin

= 4.0.4 (2021-12-30) =
* `[Changed]` Message after successfully completing conversion of images

= 4.0.3 (2021-12-20) =
* `[Security]` Added URL validation for Pass Thru loading mode (CVE-2021-25074)
* `[Fixed]` Auto-conversion images with unsupported extensions when uploading files
* `[Fixed]` Generating directory paths when ABSPATH constant is invalid

= 4.0.2 (2021-12-17) =
* `[Fixed]` Fetching large list of files to conversion
* `[Fixed]` Rewrites caching for some servers
* `[Changed]` Connection when converting using remote server

= 4.0.1 (2021-12-10) =
* `[Added]` Informational banners on plugin settings page

= 4.0.0 (2021-12-04) =
* `[Added]` Converting images using remote server
* `[Added]` Converting images to AVIF format
* `[Added]` Error detection for invalid permalinks structure

= 3.2.4 (2021-11-21) =
* `[Fixed]` Automatic image conversion when /uploads directory is not organized into monthly and yearly folders
* `[Fixed]` Displaying errors when converting images

= 3.2.3 (2021-10-15) =
* `[Added]` Exclusion of re-converting images that caused regeneration error

= 3.2.2 (2021-09-26) =
* `[Changed]` Option "Force redirections to WebP for all domains" as default
* `[Added]` Debug information for regeneration error

= 3.2.1 (2021-09-12) =
* `[Fixed]` Skipping converted images when converting all images

= 3.2.0 (2021-09-12) =
* `[Removed]` Filter `webpc_files_paths`
* `[Removed]` Filter `webpc_dir_excluded`
* `[Changed]` Error handling when converting images
* `[Added]` Filter `webpc_supported_source_file` to exclude paths to files from converting
* `[Added]` Filter `webpc_supported_source_directory` to exclude paths to directories from converting
* `[Added]` Modifications to appearance of plugin settings page

= 3.1.1 (2021-09-08) =
* `[Fixed]` Generating .htaccess files for multisite websites
* `[Changed]` Fields on plugin settings page
* `[Changed]` Server configuration error detection

= 3.1.0 (2021-09-02) =
* `[Fixed]` Default state of notice displaying
* `[Added]` Error detection for server that does not supports using .htaccess files from custom locations

= 3.0.8 (2021-07-25) =
* `[Fixed]` Compatibility of plugin settings for multisite websites

= 3.0.7 (2021-07-19) =
* `[Added]` Changes to improve performance of plugin

= 3.0.6 (2021-06-20) =
* `[Fixed]` Generating URLs for images using Pass Thru method
* `[Added]` Filter `webpc_passthru_url_nocache` to remove nocache param from URL using Pass Thru method

= 3.0.5 (2021-06-09) =
* `[Fixed]` Handling of filters for changing directory paths
* `[Fixed]` Converting using Imagick method for 100% image quality
* `[Changed]` Default conversion method from Gd to Imagick

= 3.0.4 (2021-05-28) =
* `[Fixed]` Caching rewrites on CDN and Proxy servers

= 3.0.3 (2021-05-22) =
* `[Fixed]` Rewrite rules for via .htaccess loading mode

= 3.0.2 (2021-05-22) =
* `[Fixed]` Rewrite rules for servers where DOCUMENT_ROOT is different from ABSPATH

= 3.0.1 (2021-05-09) =
* `[Fixed]` Filters using for change server paths
* `[Added]` Excluding directories when uploading images to Media Library

= 3.0.0 (2021-05-02) =
* `[Removed]` Filter `webpc_get_values`
* `[Removed]` Filter `webpc_get_options`
* `[Removed]` Filter `webpc_get_methods`
* `[Changed]` Error messages on plugin settings page
* `[Added]` Conversion of images to multiple output formats
* `[Added]` Compatibility with NextGEN Gallery plugin
* `[Added]` Data displayed on "Server configuration" tab on plugin settings page
* `[Added]` Changes to improve performance of plugin

= 2.4.0 (2021-02-28) =
* `[Fixed]` Error detection of redirects without .png as supported file extension
* `[Fixed]` Pass Thru loading mode for servers not supporting `getallheaders()` function
* `[Changed]` Level of error for cached redirects of images to WebP files
* `[Added]` Skip re-converting images that were larger than original after converting to WebP

= 2.3.0 (2021-01-31) =
* `[Fixed]` Encoding paths to files
* `[Fixed]` Retaining PNG transparency using Gd method
* `[Added]` Cron to convert images uploaded to Media Library

= 2.2.0 (2021-01-13) =
* `[Added]` Support for WordPress Multisite

= 2.1.3 (2020-12-28) =
* `[Fixed]` Regex for Pass Thru loading mode

= 2.1.2 (2020-12-27) =
* `[Fixed]` Converting images using Imagick method

= 2.1.1 (2020-12-21) =
* `[Fixed]` Modal when deactivating plugin

= 2.1.0 (2020-12-21) =
* `[Changed]` Structure of conversion methods
* `[Changed]` Structure of error detection methods

= 2.0.1 (2020-12-16) =
* `[Fixed]` Actions initiated after plugin update

= 2.0.0 (2020-12-16) =
* `[Removed]` Filter `webpc_uploads_path`
* `[Removed]` Filter `webpc_uploads_webp`
* `[Removed]` Filter `webpc_uploads_dir`
* `[Removed]` Filter `webpc_uploads_root`
* `[Changed]` Error messages in administration panel
* `[Added]` Image loading mode: `Pass Thru` (without rewrites in .htacces files or Nginx configuration)
* `[Added]` Filter `webpc_dir_name` to change default directory paths
* `[Added]` Filter `webpc_site_root` to change path for root installation directory of WordPress
* `[Added]` Filter `webpc_site_url` to change Site URL of WordPress

= 1.6.0 (2020-12-12) =
* `[Added]` Escaping functions for translated phrases
* `[Added]` Error codes in error messages on plugin settings page
* `[Added]` Modal when deactivating plugin

= 1.5.1 (2020-11-02) =
* `[Changed]` Error messages related to non-working redirects from .htaccess file

= 1.5.0 (2020-10-28) =
* `[Added]` Filter `webpc_files_paths` to modify paths of images to be converted
* `[Added]` Filter `webpc_convert_error` to management of errors content displayed during conversion
* `[Added]` Filter `webpc_convert_errors` to management of errors displayed during conversion

= 1.4.6 (2020-10-23) =
* `[Fixed]` Error detection of non-working redirects without .png as supported file extension

= 1.4.5 (2020-10-19) =
* `[Fixed]` Content for translations

= 1.4.4 (2020-10-18) =
* `[Changed]` Information after conversion process is completed

= 1.4.3 (2020-09-30) =
* `[Changed]` Directory for error detection of non-working redirects of images to WebP files
* `[Changed]` Button for `Server configuration` tab
* `[Added]` Information about error detection in `Server configuration` tab

= 1.4.2 (2020-08-24) =
* `[Fixed]` Cache-Control for redirects of images to WebP files
* `[Added]` Error detection of cached redirects of images to WebP files

= 1.4.1 (2020-08-19) =
* `[Changed]` Error detection method on plugin settings page
* `[Added]` Error detection of non-working redirects of images to WebP files

= 1.4.0 (2020-08-13) =
* `[Security]` Added validation of saved settings values
* `[Removed]` Filter `webpc_notice_url`
* `[Changed]` Error messages for server requirements
* `[Changed]` Loading CSS and JS files only on plugin settings page
* `[Changed]` Minor changes for plugin settings page
* `[Added]` Blocking redirects to WebP when displaying images on other domains
* `[Added]` Cron to automatically regenerate new images outside of Media Library
* `[Added]` Filter `webpc_cron_interval` to change cron interval
* `[Added]` Error message for incorrect plugin settings
* `[Added]` Error when converting when WebP file is larger than original and has been deleted
* `[Added]` Notice after plugin installation with description of first steps
* `[Added]` Option to log errors while converting to debug.log file
* `[Added]` Option to preserve metadata for WebP files *(available for Imagick library)*
* `[Added]` Value of `ABSPATH` in `Server configuration` tab

= 1.3.1 (2020-07-03) =
* `[Fixed]` Text Domain for Internationalization

= 1.3.0 (2020-06-12) =
* `[Removed]` Ability to skip converting existing images when `Regenerate All`
* `[Fixed]` Creating `/uploads-webpc` directory webpc after re-activation plugin
* `[Fixed]` Error message about not supporting old PHP version
* `[Fixed]` Ignoring case sensitivity when verifying image extensions
* `[Changed]` Error messages when converting images
* `[Changed]` New argument for filter `webpc_htaccess_mod_rewrite` and support for multiple .htaccess files
* `[Added]` Converting all images from `/uploads` directory *(also other than from Media Library)*.
* `[Added]` Converting images from `/plugins` directory
* `[Added]` Converting images from `/themes` directory
* `[Added]` Information about used filters in `Server configuration` tab
* `[Added]` Option to force all images to be converted again when `Regenerate All`

= 1.2.7 (2020-06-11) =
* `[Changed]` Moving converted WebP files to `/uploads-webpc/uploads` directory from `/uploads-webpc` directory *(**required manual configuration change for Nginx and WordPress Multisite**)*
* `[Changed]` Validation when converting images

= 1.2.6 (2020-05-28) =
* `[Fixed]` Removal of WebP files larger than original during upload

= 1.2.5 (2020-05-10) =
* `[Removed]` Link to plugin settings on Network Admin Screen for WordPress Multisite
* `[Fixed]` Path in RewriteRule for WordPress Multisite
* `[Changed]` Error messages in administration panel
* `[Added]` Support for `disable_functions` setting for using `set_time_limit` function
* `[Added]` Support for blocked function `file_get_contents`

= 1.2.4 (2020-04-24) =
* `[Changed]` Error messages in administration panel
* `[Added]` Action `webpc_delete_paths` to delete images by paths

= 1.2.3 (2020-04-15) =
* `[Added]` Blocking server cache for rewrite rules
* `[Added]` Detecting whether requests to images are processed by server bypassing Apache

= 1.2.2 (2020-04-08) =
* `[Changed]` Moving rules for modules `mod_mime` and `mod_expires` to `/uploads-webpc/.htaccess` file
* `[Changed]` New argument for filter `webpc_htaccess_rules` with server path of file

= 1.2.1 (2020-04-07) =
* `[Removed]` Filter `webpc_option_disabled`
* `[Fixed]` Converting images multiple times when uploading to Media Library
* `[Added]` Action `webpc_convert_paths` to convert images by paths
* `[Added]` Action `webpc_convert_attachment` to convert images by Post ID

= 1.2.0 (2020-04-05) =
* `[Changed]` Moving rules from .htaccess file in root directory of WordPress to `/wp-content/uploads` directory
* `[Added]` Ability to disable automatic removal of WebP files larger than original
* `[Added]` Error validation for a non-writable .htaccess file
* `[Added]` Filter `webpc_uploads_root` to change path for root installation directory of WordPress

= 1.1.2 (2020-03-03) =
* `[Added]` Zero padding at end for odd-sized WebP files using `GD` library

= 1.1.1 (2020-02-13) =
* `[Changed]` Unknown error handling when converting images
* `[Added]` Ability to skip converting existing images when `Regenerate All`
* `[Added]` Button for simple checking of server configuration

= 1.1.0 (2020-02-10) =
* `[Fixed]` Support for WordPress installation in subdirectory
* `[Fixed]` Error detecting WebP support by Imagick

= 1.0.9 (2020-01-03) =
* `[Added]` Limit of maximum image resolution limit using `GD` library

= 1.0.8 (2019-12-19) =
* `[Fixed]` File deletion for custom paths with converted WebP files
* `[Changed]` Rules management in .htaccess file when activating or deactivating plugin
* `[Added]` Error detection system in server configuration
* `[Added]` Blocking image conversion when `GD` or `Imagick` libraries are unavailable

= 1.0.7 (2019-12-17) =
* `[Changed]` Rewrite rules in .htaccess file
* `[Added]` Custom path support for original uploads files
* `[Added]` Custom path support for saving converted WebP files
* `[Added]` Filter `webpc_uploads_path` to change path for original uploads files
* `[Added]` Filter `webpc_uploads_webp` to change path for saving converted WebP files

= 1.0.6 (2019-11-06) =
* `[Changed]` Way of generating file path _(without `ABSPATH`)_
* `[Added]` Automatic deletion of converted files larger than original

= 1.0.5 (2019-09-16) =
* `[Added]` Information on available FAQ

= 1.0.4 (2019-07-11) =
* `[Changed]` Limits of maximum execution time

= 1.0.3 (2019-06-26) =
* `[Security]` Fixed CSRF vulnerability when saving plugin settings (CVE-2019-15834)

= 1.0.2 (2019-06-25) =
* `[Changed]` Error messages
* `[Added]` Tab in Settings page about server configuration

= 1.0.1 (2019-06-23) =
* `[Security]` Added permission check for endpoints in REST API
* `[Added]` Error handler for undefined `GD` extension

= 1.0.0 (2019-06-16) =
* The first stable release
